class MoneyDt

    # Example:
    #   >> MoneyDt.conversion_rates("EUR", { "USD" => 1.10 })
    #   >> MoneyDt.new(10, "EUR") + MoneyDt.new(10, "USD") #=> <MoneyDt amount:1909/100, currency:EUR>
    #
    # Arguments:
    #   another: MoneyDt
    #
    def +(another)
        if self.currency == another.currency
            MoneyDt.new(self.amount + another.amount, self.currency)
        else
            another_converted = another.convert_to(self.currency)
            MoneyDt.new(self.amount + another_converted.amount, self.currency)
        end
    end

    # Example:
    #   >> MoneyDt.conversion_rates("EUR", { "USD" => 1.10 })
    #   >> MoneyDt.new(10, "EUR") - MoneyDt.new(10, "USD") #=> <MoneyDt amount:91/100, currency:EUR>
    #
    # Arguments:
    #   another: MoneyDt
    #
    def -(another)
        if self.currency == another.currency
            MoneyDt.new(self.amount - another.amount, self.currency)
        else
            another_converted = another.convert_to(self.currency)
            MoneyDt.new(self.amount - another_converted.amount, self.currency)
        end
    end

    # Example:
    #   >> MoneyDt.new(10, "USD") / 2 #=> <MoneyDt amount:5/1, currency:USD>
    #
    # Arguments:
    #   value: Fixnum, Float
    #
    def /(value)
        MoneyDt.new(self.amount / value, self.currency)
    end

    # Example:
    #   >> MoneyDt.new(10, "USD") * 2 #=> <MoneyDt amount:20/1, currency:USD>
    #
    # Arguments:
    #   value: Fixnum, Float
    #
    def *(value)
        MoneyDt.new(self.amount * value, self.currency)
    end
end
